<?php
/**
 * 素材库
 */

$type = array
(
	'image' => '图片',
	'voice' => '语音',
	'video' => '视频',
	'thead' => '图文',
	'thumb' => '缩略图',
);

return array
(
	# 表名
	'name' => 'media',
	# 显示给用户看的名称
	'lang' => '多媒体素材管理',
	# 数据结构
	'struct' => array
	(
		'id' 		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> 'ID',
			'default' 	=> '',
			'desc' 		=> '',
			'match' 	=> 'is_numeric',
			'search'	=> 'order',
			'list'		=> true,
		),

		'site'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '站点',
			'default' 	=> '',
			'desc' 		=> '请输入站点',
			'match' 	=> 'is_numeric',
			//'search'	=> 'order,fulltext',
			//'update'	=> 'text',
			//'list'		=> true,
		),
		
		'mid'		=> array
		(
			'type' 		=> 'varchar-150',
			'name' 		=> '素材id',
			'default' 	=> '',
			'desc' 		=> '素材id',
			'search'	=> 'fulltext',
			//'list'		=> true,
			'match' 	=> 'option',
		),
		
		'name'		=> array
		(
			'type' 		=> 'varchar-50',
			'name' 		=> '标题',
			'default' 	=> '',
			'desc' 		=> '请输入标题',
			'match' 	=> 'is_string',
			'search'	=> 'fulltext',
			'list'		=> true,
		),
		
		'file'		=> array
		(
			'type' 		=> 'varchar-150',
			'name' 		=> '原文件地址',
			'default' 	=> '',
			'desc' 		=> '请输入原文件地址',
			'match' 	=> 'is_string',
			'list'		=> 'table',
			'modal'		=> '查看详情',
		),
		
		'down_url'		=> array
		(
			'type' 		=> 'varchar-150',
			'name' 		=> '下载地址',
			'default' 	=> '',
			'desc' 		=> '请输入下载地址',
			'match' 	=> 'is_string',
			//'list'		=> true,
		),
		
		'type'		=> array
		(
			'type' 		=> 'varchar-10',
			'name' 		=> '类型',
			'default' 	=> 'image',
			'desc' 		=> '请选择类型',
			'match' 	=> 'is_string',
			'option' 	=> $type,
			//'update'	=> 'radio',
			'list'		=> true,
		),
		
		'content_id'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '是否被消息使用',
			'default' 	=> '-1',
			'desc' 		=> '是否被消息使用',
			'list'		=> '{content_id} < 0 ? "未被使用" : "已被使用"',
			'match' 	=> 'option',
		),
		
		'cdate'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '录入时间',
			'match' 	=> array('is_numeric', time()),
			'desc' 		=> '',
			# 只有insert时才生效
			'insert'	=> true,
			'list'		=> 'date("Y-m-d H:i:s", {cdate})',
		),
	),
	
	'manage' => array
	(
		# 同时更新另外一个表
		//'updateTable' => 'weixin/message',
	),

	'auth' => 'site',
	
	# request 请求接口定义
	'request' => array
	(
		'file' => array
		(
			'where' => array
			(
				'file' => 'yes',
				//'site' => 'yes',
			),
			'type' => 'one',
		),
		
		'use' => array
		(
			'where' => array
			(
				'type' => 'yes',
				'content_id' => 'yes',
				//'site' => 'yes',
			),
			'type' => 'one',
		),
		
		'all' => array
		(
			'where' => array
			(
				'state' => 1,
				//'site' => 'yes',
			),
			'type' => 'all',
			'order' => array('id', 'desc'),
			'col' => '*|id',
		),
	),
);
