<?php

# 定义几个常用的选项
$option = array
(
	1 => '正常',
	2 => '删除',
);

return array
(
	# 表名
	'name' => 'thead',
	# 显示给用户看的名称
	'lang' => '文章管理',
	# 后台菜单排序
	'order' => 15,
	# 数据结构
	'struct' => array
	(
	
		'id' 		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '文章ID',
			'default' 	=> '',
			'desc' 		=> '',
			'match' 	=> 'is_numeric',
			'search'	=> 'order',
			'list'		=> true,
			'order'		=> 'desc',
		),
		
		'site'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '站点',
			'default' 	=> '',
			'desc' 		=> '请输入站点',
			'match' 	=> 'is_numeric',
			//'search'	=> 'order,fulltext',
			//'update'	=> 'text',
			//'list'		=> true,
		),
		
		'name'		=> array
		(
			'type' 		=> 'varchar-32',
			'name' 		=> '文章标题',
			'default' 	=> '',
			'desc' 		=> '请输入文章标题',
			'match' 	=> 'is_string',
			'update'	=> 'text',
			'search'	=> 'order,fulltext',
			'list'		=> 'Dever::load("weixin/thead.link", {id})',
		),

		'reorder'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '排序(数值越大越靠前)',
			'default' 	=> '1',
			'desc' 		=> '请输入排序',
			'match' 	=> 'option',
			'update'	=> 'text',
			'search'	=> 'order',
			'list'		=> true,
			'order'		=> 'desc',
		),
		
		'num_view'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '浏览量pv',
			'default' 	=> '0',
			'desc' 		=> '请填写浏览量pv',
			'match' 	=> 'option',
			'list'		=> true,
		),

		'author'		=> array
		(
			'type' 		=> 'varchar-80',
			'name' 		=> '文章作者-选填，可为空',
			'default' 	=> '',
			'desc' 		=> '请输入文章作者',
			'match' 	=> 'option',
			//'update'	=> 'text',
			//'list'		=> true,
		),
		
		'content'		=> array
		(
			'type' 		=> 'text-255',
			'name' 		=> '内容',
			'default' 	=> '',
			'desc' 		=> '请输入内容',
			'match' 	=> 'is_string',
			'update'	=> 'editor',
			'key' 		=> 1,
		),

		'state'		=> array
		(
			'type' 		=> 'tinyint-1',
			'name' 		=> '状态',
			'default' 	=> '1',
			'desc' 		=> '请选择状态',
			'match' 	=> 'is_numeric',
			'option' 	=> $option,
			'update'	=> 'radio',
		),
		
		'cdate'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '录入时间',
			'match' 	=> array('is_numeric', time()),
			'desc' 		=> '',
			# 只有insert时才生效
			'insert'	=> true,
			'list'		=> 'date("Y-m-d H:i:s", {cdate})',
		),
	),

	'auth' => 'site',
	
	# request 请求接口定义
	'request' => array
	(
		'info' => array
		(
			'where' => array
			(
				'id' => 'yes',
				'site' => 'yes',
			),

			'type' => 'all',
			'order' => array('reorder` desc,`id', 'desc'),
			'limit' => array(1,0),
			//'page' => array(15, 'list'),
			# *为读取的字段，id为以这个字段为索引
			'col' => '*|id',
		),

		'get' => array
		(
			# 匹配的正则或函数 选填项
			'option' => array
			(
				'id' => 'yes',
				'site' => 'yes',
			),
			'type' => 'all',
			'order' => array('reorder` desc,`id', 'desc'),
			'limit' => array(5, 0),
			'col' => '*',
		),
		
		# 更新浏览量
		'addView' => array
		(
			'type' => 'update',
			'where' => array
			(
				'id' => 'yes',
				'site' => 'yes',
			),
			'set' => array
			(
				'num_view' => array('1', '+='),
			),
		),
	),
);
