<?php
/*
|--------------------------------------------------------------------------
| code.php 二维码管理
|--------------------------------------------------------------------------
*/
namespace Weixin\Src;

use Dever;
use Weixin\Src\Lib\Core;

class Code
{
	/**
     * 获取ticket
     * 
     * @return mixed
     */
	public function update($param = '')
	{
		$table = Dever::input('table');
		
		$id = Dever::input('update_where_id');

		$id = $id ? $id : $param;

		$type = Dever::input('update_type');
		
		if ($id > 0) {
			$info = Dever::load('weixin/code-one', $id);
		}
		
		if (!isset($info)) {
			return;
		}
		
		Dever::setInput('action_name', $info['type']);
		
		Dever::setInput('scene_id', $info['id']);

		$data = Dever::load('weixin/data.code_ticket');
		
		if ($data && isset($data['data']) && isset($data['data']['ticket'])) {
			Dever::load('weixin/code-update', array('where_id' => $info['id'], 'set_ticket' => $data['data']['ticket'], 'set_url' => $data['data']['url'], 'set_expire' => $data['data']['expire_seconds']));
		}
	}
	
	/**
     * 获取短链接
     * 
     * @return mixed
     */
	public function link($param = '')
	{
		$table = Dever::input('table');
		
		$id = Dever::input('update_where_id');

		$id = $id ? $id : $param;

		if ($id > 0) {
			$info = Dever::load('weixin/link-one', $id);
		}
		
		if (!isset($info)) {
			return;
		}

		Dever::setInput('url', $info['url']);

		$data = Dever::load('weixin/data.code_link');
		
		if ($data && isset($data['data']) && isset($data['data']['short_url'])) {
			Dever::setInput('DEVER_onload', 'no');
			
			Dever::load('weixin/link-update', array('where_id' => $info['id'], 'set_short_url' => $data['data']['short_url']));
		}
	}
}