<?php
/*
|--------------------------------------------------------------------------
| data.php 数据获取
|--------------------------------------------------------------------------
*/
namespace Weixin\Src;

use Dever;
use Weixin\Src\Lib\Core;

class Data
{
	/**
	 * site
	 *
	 * @var Core
	 */
	private $site;
	
	/**
	 * token
	 *
	 * @var string
	 */
	private $token;

	/**
	 * core
	 *
	 * @var string
	 */
	private $core;
	
	/**
	 * config
	 *
	 * @var array
	 */
	private $config;
	
	/**
	 * result
	 *
	 * @var mixed
	 */
	private $result;
	
	/**
     * 构造函数　初始化
     * 
     * @return mixed
     */
	public function __construct()
	{
		$this->site = Dever::input('site', 1);

		$this->core = new Core($this->site);
		
		$this->token = $this->core->token();
		
		$this->config = Dever::config('interface', 'weixin');
	}
	
	/**
     * 
     * 
     * @return mixed
     */
	private function handle($method, $param)
	{
		$this->config['current'] = $this->config[$method];

		if (!isset($this->config['current']['param']['access_token']) && $param) {
			$this->config['current']['param'] = $param;
		}
		
		foreach ($this->config['current']['param'] as $k => $v) {
			if ($k == 'access_token') {
				$this->config['current']['url'] .= $k . '=' . $this->token;
				unset($this->config['current']['param'][$k]);
			} elseif (isset($param[$k]) && $param[$k]) {
				$this->config['current']['param'][$k] = $param[$k];
			} elseif($v) {
				$this->config['current']['param'][$k] = $v;
			}
		}
		
		$type = isset($this->config['current']['json']) ? 'json' : '';
		
		//print_r($this->config['current']);
		
		$this->result = json_decode(Dever::curl($this->config['current']['url'], $this->config['current']['param'], $type), true);
		
		//$this->result['errcode'] = 0;
		//$this->result['errmsg'] = 'ok';
		
		//print_r($this->result);die;
		
		//$this->result['group'] = array('id' => 103, 'name' => 'test');
		
		if (isset($this->result['errcode']) && $this->result['errcode'] != 0) {
			# 清空token，重新请求
			if (strpos($this->result['errmsg'], 'token') !== false) {
				//$this->token = $this->core->token(2);
				//$this->handle($method, $param);
				return false;
			} else {
				//print_r($this->result);die;
				return false;
			}
		}
		
		return true;
	}
	
	/**
     * __call
     *
     * @return object
     */
    public function __call($method, $param = array())
    {
		if (!isset($this->config[$method])) {
			return false;
		}
		
		if (isset($param[0])) {
			$param = $param[0];
		}

		$state = $this->handle($method, $param);
		if (!$state) {
			$result['status'] 	= -1;
			$result['msg'] 		= 'error';
			$result['data']		= $this->result;
			
			return $result;
		}
		
		$method = '_' . $method . '_action';
		
		if (method_exists($this, $method)) {
			return $this->$method($param);
		} else {
			$this->action($param);
		}
		
		//$this->result
		$result['status'] 	= 1;
		$result['msg'] 		= 'yes';
		$result['data']		= $this->result;

		return $result;
    }
    
    /**
     * 默认处理数据
     * 
     * @return mixed
     */
	private function action($param)
	{
		if (isset($this->config['current']['action']) && isset($this->config['current']['action']['method'])) {
			$data = $this->config['current']['action']['data'];
			$method = $this->config['current']['action']['method'];
			if (isset($this->result['data'][$data])) {
				foreach ($this->result['data'][$data] as $k => $v) {
					$send[$data] = $v;
					$this->$method($send);
				}
			}
			if (isset($this->result['next_openid']) && $this->result['next_openid']) {
				# 如果是获取用户列表，则继续获取下去
				$send['next_openid'] = $this->result['next_openid'];
				//$this->user_list($send);
			}
		} elseif (isset($this->config['current']['action']) && isset($this->config['current']['action']['where'])) {
			$where = $this->config['current']['action']['where'];
			$table = $this->config['current']['action']['table'];
			
			$result = isset($this->config['current']['action']['data']) ? $this->result[$this->config['current']['action']['data']] : $this->result;

			if ($result) {
				if (!isset($result[0])) {
					$this->update($where, $table, $result, $param);
				} else {
					foreach ($result as $k => $v) {
						$this->update($where, $table, $v);
					}
				}
			}
		}
	}
	
	/**
     * 更新数据
     * 
     * @return mixed
     */
	private function update($where, $table, $value, $param = array())
	{
		$info = array();
		$id = false;
		if ($param && is_numeric($param) && $param > 0) {
			# 传过来的是id
			$id = $param;
			$param = false;
		}
		/*
		if($id = Dever::input('where_id'))
		{
			$id = $id > 0 ? $id : false;
		}
		*/
		
		if (!$id) {
			if (!$param) {
				$param = $value;
			}
			foreach ($where as $k => $v) {
				if (isset($param[$v])) {
					if(!is_string($k))
					{
						$k = $v;
					}
					if ($param[$v] === 0) {
						$param[$v] = -1;
					}
					$info['where_' . $k] = $param[$v];
				}
			}
		}

		$info['where_site'] = $this->site;
		
		if ($info) {
			$info = $id > 0 ? Dever::load('weixin/'.$table.'-one', $id) : Dever::load('weixin/'.$table.'-info', $info);

			$data = array();

			# load为1，则不再继续执行
			Dever::setInput('DEVER_onload', 'no');
			if ($info) {
				//update
				$data['where_id'] = $info['id'];
				$data['set_site'] = $this->site;
				$data['set_mdate'] = time();
				$prefix = 'set';
				$method = 'update';
			} else {
				//insert
				$data['add_site'] = $this->site;
				$prefix = 'add';
				$method = 'insert';
			}

			$update = isset($this->config['current']['action']['update']) ? $this->config['current']['action']['update'] : array();
			
			foreach ($value as $k => $v) {
				if ($v === 0) {
					$v = -1;
				}
				if (isset($update[$k]) && $update[$k]) {
					$data[$prefix . '_' . $update[$k]] = $v;
				} else {
					$data[$prefix . '_' . $k] = $v;
				}
			}
			
			if ($data) {
				Dever::load('weixin/'.$table.'-' . $method, $data);
			}
		}
	}
    
    /**
     * 处理用户信息
     * 
     * @return mixed
     *
	private function _user_list_action($param)
	{
		print_r($this->result);die;
		foreach($this->result['data']['openid'] as $k => $v)
		{
			$param['openid'] = $v;
			$this->user_info($param);
		}
	}
	
	/**
     * 处理用户信息
     * 
     * @return mixed
     *
	private function _user_info_action($param)
	{
		$where['where_openid'] = $param['openid'];
		$info = Dever::load('weixin/user-info', $where);
		if($info)
		{
			//update
			$data['where_id'] = $info['id'];
			$prefix = 'set';
			$method = 'update';
		}
		else
		{
			//insert
			$prefix = 'add';
			$method = 'insert';
		}

		foreach($this->result as $k => $v)
		{
			$update[$prefix . '_' . $k] = $v;
		}
		
		Dever::load('weixin/user-' . $method, $data);
	}
	*/
}