<?php
/*
|--------------------------------------------------------------------------
| media.php 多媒体 上传素材
|--------------------------------------------------------------------------
*/
namespace Weixin\Src;

use Dever;
use Weixin\Src\Lib\Core;

class Media
{
	/**
     * 新增数据 属于hack。无需有返回值
     * 
     * @return mixed
     */
	public function update($param = '')
	{
		//$table = Dever::input('table');
		$id = Dever::input('update_where_id');

		$id = $id ? $id : $param;
		
		if (!$id) {
			return;
		}
		
		# 读取到当前的站点id
		$site = Dever::load('manage/auth.getTop', 'weixin-site');
		if (!$site) {
			return;
		}
		Dever::setInput('site', $site['value']);

		
		$name = Dever::input('update_name');
		$type = Dever::input('update_type');
		if (is_array($type)) {
			$type = $type[0];
		}
		
		$temp = Dever::input('update_temp');
		if (is_array($temp)) {
			$temp = $temp[0];
		}
		
		# 只针对需要把素材上传到微信的
		if ($type == 3) {
			# 图文消息处理
			//$data = Dever::$global['base']['_param'];
			
			$content = Dever::param('content_3');
			
			$type = 'image';
			
			$author = '';
			
			foreach ($content as $k => $v) {
				$cover = 0;
				if ($k == 0) {
					$cover = 1;
				}
				
				# 将封面上传到素材库
				$get = $this->create($v['title'], $id, $v['pic'], 'thumb', $temp);
				if (!$get) {
					return;
				}
				
				$data[] = $this->thead_param($get['media_id'], $v['title'], $v['desc'], $v['link'], $v['info'], $v['author'], $cover);
			}
			
			$this->create($name, $id, false, 'thead', $temp, $data);
			
			return;
		} elseif ($type == 4) {
			# 语音
			$file = Dever::input('update_mp3');
			$type = 'voice';
		} elseif ($type == 5) {
			# 视频
			$file = Dever::input('update_mp4');
			$type = 'video';
		} elseif ($type == 6) {
			# 图片
			$file = Dever::input('update_pic');
			$type = 'image';
		} else {
			return;
		}
		
		$this->create($name, $id, $file, $type, $temp);
	}
	
	/**
     * 更新素材
     * 
     * @return mixed
     */
	private function create($name, $id, $file, $type, $temp = 1, $data = array())
	{
		if (!$id) {
			return;
		}
		
		$info = array();
		
		if ($file) {
			$info = Dever::load('weixin/media-file', array('where_file' => $file));
			if ($info) {
				$info['media_id'] = $info['mid'];
				return $info;
			}
		}

		if (!$info) {
			# 先检测当前id是否用到了其他素材
			$old = Dever::load('weixin/media-use', array('where_type' => $type, 'where_content_id' => $id));
			if ($old) {
				if (($file && $old['file'] != $file) || !$file) {
					#　如果素材不是同一个，则将旧有素材解绑
					Dever::load('weixin/media-update', array('where_id' => $old['id'], 'set_content_id' => '-1'));
					
					# 这里可以考虑是否删除旧的素材
					//Dever::setInput('media_id', $old['mid']);
					//Dever::load('weixin/data.media_delete');
				}
			}
		
			if ($data) {
				$data = $this->add_thead($data);
			} else {
				$data = $this->add($file, $type, $temp);
			}
			
			if ($data) {
				$param['add_mid'] = $data['media_id'];
				$param['add_type'] = $type;
				$param['add_name'] = $name;
				$param['add_file'] = $file;
				$param['add_down_url'] = isset($data['url']) ? $data['url'] : '';
				$param['add_content_id'] = $id;
				Dever::load('weixin/media-insert', $param);
			}

			return $data;
		}
	}

	/**
     * 上传文件
     * 
     * @return mixed
     */
	private function add($file, $type, $temp = 1)
	{
		$file = str_replace(Dever::$global['host']['image'], DEVER_PATH . 'data/upload/', $file);
		
		if(strpos($file, 'http://') !== false)
		{
			# 临时copy下来吧，然后再删除
			$old = $file;
			$file = DEVER_PATH . 'data/upload/' . md5($old) . '.' . pathinfo($old, PATHINFO_EXTENSION);
			copy($old, $file);
		}

		$file_info = array
		(
            'filename' => md5($file),
            'content-type'=> mime_content_type($file),
            'filelength'=> filesize($file)
        );

		Dever::$global['base']['temp_media'] = array
		(
			'access_token' => 'token',
			'type' => $type,
			'media' => "@" . $file,
			'form-data' => $file_info,
		);

		# 新增
		if($temp == 1)
		{
			# 临时素材
			$data = Dever::load('weixin/data.media_add_temp', Dever::$global['base']['temp_media']);
		}
		else
		{
			$data = Dever::load('weixin/data.media_add', Dever::$global['base']['temp_media']);
		}
		
		if(isset($old) && $old)
		{
			unlink($file);
		}

		if($data && $data['status'] == 1)
		{
			return $data['data'];
		}
		else
		{
			return array();
		}
	}
	
	/**
     * 图文素材的param拼装
     * 
     * @return mixed
     */
	private function thead_param($mid, $title, $content, $url, $desc, $author, $cover)
	{
		$data = array
		(
            'thumb_media_id' => $mid,
            'author'=> $author,
            'title'=> $title,
            'content_source_url'=> $url,
            'content'=> $content,
            'digest' => $desc,
            'show_cover_pic'=> $cover,
        );

		return $data;
	}
	
	/**
     * 上传文章
     * 
     * @return mixed
     */
	private function add_thead($articles)
	{
		Dever::$global['base']['temp_media_thead'] = array
		(
			'access_token' => 'token',
			'articles' => $articles,
		);

		$data = Dever::load('weixin/data.media_add_thead', Dever::$global['base']['temp_media_thead']);

		if($data && $data['status'] == 1)
		{
			return $data['data'];
		}
		else
		{
			return array();
		}
	}

	/**
     * 获取media
     * 
     * @return mixed
     */
	public function get($param)
	{
		$mid = $param[0];
		$type = $param[1];

		Dever::setInput('media_id', $mid);

		$data = false;

		//$data = Dever::load('weixin/data.media_get');

		$result = '语音和视频暂时无法解析<br />后续完成';
		if($data && isset($data['data']))
		{
			if($type == 'video')
			{

			}

			if($type == 'vioce')
			{
				
			}
		}

		return $result;
	}

	/**
     * 获取上传需要的数据
     * 
     * @return mixed
     */
	public function data()
	{
		return isset(Dever::$global['base']['temp_media']) ? Dever::$global['base']['temp_media'] : array();
	}
	
	/**
     * 获取上传图文需要的数据
     * 
     * @return mixed
     */
	public function data_thead()
	{
		return isset(Dever::$global['base']['temp_media_thead']) ? Dever::$global['base']['temp_media_thead'] : array();
	}
}