<?php
/*
|--------------------------------------------------------------------------
| user.php 处理用户信息
|--------------------------------------------------------------------------
*/
namespace Weixin\Src;

use Dever;
use Weixin\Src\Lib\Core;

class User
{
	/**
     * sync
     * 
     * @return mixed
     */
	public function sync()
	{
		Dever::setInput('openid', Dever::input('openid'));

		$data = Dever::load('weixin/data.user_info');
		if ($data && isset($data['data']) && isset($data['data']['groupid'])) {
			# 分组用户数量加+1
			Dever::load('weixin/group-upNum', array('where_groupid' => $data['data']['groupid'], 'set_count' => 1));
		}
		
		return 1;
	}
	
	/**
     * 根据openid获取用户信息
     * 
     * @return mixed
     */
	public function name($openid = false)
	{
		$info = $this->info($openid);

		if ($info) {
			return '<div style="text-align:center"><img src="'.$info['headimgurl'].'" width="80" height="80"><br /><span>' . $info['country'] . ' ' . $info['province'] . ' ' . $info['city'] . '</span><br /><span>' . $info['nickname'] . '</span></div>';
		}

		return '匿名用户';
	}

	/**
     * 根据openid获取用户信息
     * 
     * @return mixed
     */
	public function info($openid = false)
	{
		return Dever::load('weixin/user-info', array('where_openid' => $openid));
	}

	/**
     * 获取消息的内容
     * 
     * @return mixed
     */
	public function msg($param)
	{
		# 查找消息是否存在
		$info = is_array($param) ? $param : Dever::load('weixin/usermsg-one', $param);

		if ($info) {
			$html = '';
			$info['content'] = json_decode(base64_decode($info['content']), true);
			$content = $info['content'][0];
			# 其实只有语音和视频是才要解析
			# 地图需要载入地图组件
			switch ($info['type']) {
				case 'voice':
				case 'video':
					$html = Dever::load('weixin/media.get', array($content['MediaId'], $info['type']));
					break;

				case 'image':

					$content['PicUrl'] = str_replace('http://', 'https://', $content['PicUrl']);
					$content['PicUrl'] = str_replace('qpic.cn', 'qlogo.cn', $content['PicUrl']);
					$html = '<a href="'.$content['PicUrl'].'" target="_blank"><img src="'.$content['PicUrl'].'" width="120"></a>';
					break;

				default:
					$html = $info['info'];
					break;
			}


			return $html;
		}

		return '';
	}

	/**
     * 修改用户的分组
     * 
     * @return mixed
     */
	public function update_group($param = false)
	{
		$id = Dever::input('update_where_id');
		
		if ($id > 0) {
			$gid = Dever::input('update_groupid');
			$info = Dever::load('weixin/user-one', $id);
			
			if ($gid < 0) {
				#　挪不了
				Dever::setInput('update_groupid', $info['groupid']);
				die;
			} else {
				if ($info['openid']) {
					Dever::setInput('openid', $info['openid']);
					
					Dever::setInput('to_groupid', $gid);
					
					Dever::load('weixin/data.group_move');
					
					# 更新数量
					Dever::load('weixin/group-upNum', array('where_groupid' => $gid, 'set_count' => 1));
					Dever::load('weixin/group-upNum', array('where_groupid' => $info['groupid'], 'set_count' => -1));
				}
			}
		}
	}
	
	/**
     * 删除用户分组
     * 
     * @return mixed
     */
	public function delete_group($param = false)
	{
		$id = Dever::input('where_id');
		
		if ($id > 0) {
			$info = Dever::load('weixin/group-one', $id);
			
			if ($info && $info['count'] < 0) {
				Dever::setInput('group', $info['groupid']);
					
				Dever::load('weixin/data.group_delete');
			}
		}
	}
}